* 4 x 20 LCD output with cursor checking for line wrap.

* This routine will replace the 2x40 LCD output with the same label name
* that writes character data. Add patch to current source file. Note that
* a delay of several microseconds will be added due to the wait for the
* LCD to perform the display update and provide a cursor location.

* Output character to display...
LCDOUT  STAA  LCDBAS+1           * display character
LCDLP   ldaa    LCDBAS          * read next character position
        bmi     LCDLP           * test if busy and wait if true

        cmpa    #$13            * test for line 1 wrap
        beq     LCD1            * if match, correct line wrap
        cmpa    #$53            * test for line 2 wrap
        beq     LCD2            * if match, correct line wrap
        cmpa    #$27            * test for line 2 wrap
        beq     LCD3            * if match, correct line wrap
        rts
* correct line 1 wrap from line 3 to line 2
LCD1
        ldaa    #$40            * load line 2 start position
        oraa    #$80            * set command bit
        staa    LCDBAS          * write to display
        rts
* correct line 2 wrap from line 4 to line 3
LCD2
        ldaa    #$14            * load line 3 start position
        oraa    #$80            * set command bit
        staa    LCDBAS          * write to display
        rts
* correct line 3 wrap from line 2 to line 4
LCD3
        ldaa    #$54            * load line 4 start position
        oraa    #$80            * set command bit
        staa    LCDBAS          * write to display
        rts
